## libcgns 3.1.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  if (${CMAKE_MAJOR_VERSION} GREATER 2 OR ${CMAKE_MINOR_VERSION} GREATER 7)
    cmake_policy(SET CMP0015 OLD)
  endif (${CMAKE_MAJOR_VERSION} GREATER 2 OR ${CMAKE_MINOR_VERSION} GREATER 7)
endif(COMMAND cmake_policy)

set(CMAKE_BUILD_TYPE "Release" CACHE STRING
  "one of: Release, Debug, RelWithDebInfo or MinSizeRel")
if (${CMAKE_MAJOR_VERSION} GREATER 2 OR ${CMAKE_MINOR_VERSION} GREATER 7)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Release;Debug;RelWithDebInfo;MinSizeRel")
endif (${CMAKE_MAJOR_VERSION} GREATER 2 OR ${CMAKE_MINOR_VERSION} GREATER 7)

project("cgns" C)
set(CGNS_VERSION "3.1")

# Allow for building a package
set(CPACK_PACKAGE_VERSION "${CGNS_VERSION}-develop")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "cgns-${CGNS_VERSION}")
set(CPACK_GENERATOR "STGZ;TGZ;ZIP")
set(CPACK_SOURCE_GENERATOR "STGZ;TGZ;ZIP")
include(CPack)

CONFIGURE_FILE(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
	"${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# if this is cygwin, turn off win32 flag
if (CYGWIN)
  set(WIN32 "NO")
endif (CYGWIN)

##############
# build mode #
##############

# get some type sizes
include(CheckTypeSize)
CHECK_TYPE_SIZE(long SIZE_OF_LONG)
CHECK_TYPE_SIZE(off_t SIZE_OF_OFF_T)

if ("${SIZE_OF_OFF_T}" LESS 8)
  option(ENABLE_LFS "Enable or disable large file support" "OFF")
endif ("${SIZE_OF_OFF_T}" LESS 8)

if ("${CMAKE_SIZEOF_VOID_P}" GREATER 4)
  option(ENABLE_64BIT "Enable or disable 64-bit code building" "OFF")
else ("${CMAKE_SIZEOF_VOID_P}" GREATER 4)
  set(ENABLE_64BIT "OFF")
endif ("${CMAKE_SIZEOF_VOID_P}" GREATER 4)

option(ENABLE_LEGACY "Enable or disable building legacy code (3.0 compatible)" "OFF")
option(ENABLE_SCOPING "Enable or disable scoping of enumeration values" "OFF")

if (ENABLE_LEGACY)
  set(ENABLE_64BIT "OFF")
  mark_as_advanced(FORCE ENABLE_64BIT)
else (ENABLE_LEGACY)
  mark_as_advanced(CLEAR ENABLE_64BIT)
endif (ENABLE_LEGACY)

if (ENABLE_64BIT)
  set(ENABLE_LEGACY "OFF")
  mark_as_advanced(FORCE ENABLE_LEGACY)
else (ENABLE_64BIT)
  mark_as_advanced(CLEAR ENABLE_LEGACY)
endif (ENABLE_64BIT)

if (ENABLE_LFS)
  if (WIN32)
    add_definitions(-DHAVE_LSEEK64 -DHAVE_LSEEK64)
  else (WIN32)
    include(CheckFunctionExists)
    CHECK_FUNCTION_EXISTS(open64 HAVE_OPEN64)
    CHECK_FUNCTION_EXISTS(lseek64 HAVE_LSEEK64)
    if (HAVE_OPEN64)
      add_definitions(-DHAVE_LSEEK64)
    endif (HAVE_OPEN64)
    if (HAVE_OPEN64)
      add_definitions(-DHAVE_LSEEK64)
    endif (HAVE_LSEEK64)
  endif (WIN32)
else (ENABLE_LFS)
  remove_definitions(-DHAVE_OPEN64 -DHAVE_LSEEK64)
endif (ENABLE_LFS)

option(ENABLE_TESTS "Enable test programs" "OFF")
if (ENABLE_TESTS)
  enable_testing()
endif (ENABLE_TESTS)

###########
# Fortran #
###########

# Allow fortran support to be toggled
option(ENABLE_FORTRAN "Enable or disable the use of Fortran" "OFF")
if (NOT DEFINED FORTRAN_NAMING)
  set(FORTRAN_NAMING "UNKNOWN")
endif (NOT DEFINED FORTRAN_NAMING)
set(F2CLIST  "LOWERCASE" "LOWERCASE_" "LOWERCASE__" "UPPERCASE" "UPPERCASE_" "UPPERCASE__")
set(FORTRAN_NAMING_HELP
"Configures how to link the Fortran components into the C library.
Options are:
	LOWERCASE
	LOWERCASE_
	LOWERCASE__
	UPPERCASE
	UPPERRCASE_
	UPPERRCASE__
LOWERCASE_ is known to work with gfortran.  If this setting
does not work with your compiler, try the others until one does.
")

# If we are using fortran, enable it and configure the C-Fortran interface
# It would be nice to automatically detect this setting

if(ENABLE_FORTRAN)
  mark_as_advanced(CLEAR FORTRAN_NAMING)
  #only do this once
  if (FORTRAN_NAMING STREQUAL "UNKNOWN")
    enable_language("Fortran" OPTIONAL)
    set(HAS_FORTRAN ${CMAKE_Fortran_COMPILER_WORKS} CACHE INTERNAL "")
    # if no Fortran compiler, skip this
    if (CMAKE_Fortran_COMPILER_WORKS)
      foreach(nc ${F2CLIST})
        try_compile(NAMING_TEST_RESULT
	    "${CMAKE_BINARY_DIR}/fortran_test"
	    "${CMAKE_SOURCE_DIR}/fortran_test"
	    projectName ${nc})
        if(${NAMING_TEST_RESULT} STREQUAL "TRUE")
          set(FORTRAN_NAMING "${nc}" CACHE STRING ${FORTRAN_NAMING_HELP})
          if (${CMAKE_MAJOR_VERSION} GREATER 2 OR ${CMAKE_MINOR_VERSION} GREATER 7)
            set_property(CACHE FORTRAN_NAMING PROPERTY STRINGS ${F2CLIST})
          endif (${CMAKE_MAJOR_VERSION} GREATER 2 OR ${CMAKE_MINOR_VERSION} GREATER 7)
          message(STATUS "Trying Fortran naming convention ${FORTRAN_NAMING}: success")
          message(STATUS "Setting fortran naming convention to ${FORTRAN_NAMING}")
          break()
        else(${NAMING_TEST_RESULT} STREQUAL "TRUE")
          message(STATUS "Trying Fortran naming convention ${nc}: failure")
        endif(${NAMING_TEST_RESULT} STREQUAL "TRUE")
      endforeach(nc ${F2CLIST})
    endif (CMAKE_Fortran_COMPILER_WORKS)
  endif (FORTRAN_NAMING STREQUAL "UNKNOWN")
else(ENABLE_FORTRAN)
  mark_as_advanced(FORCE FORTRAN_NAMING)
endif(ENABLE_FORTRAN)

# check that FORTRAN_NAMING is valid
if (ENABLE_FORTRAN)
  if (FORTRAN_NAMING STREQUAL "UNKNOWN")
    if (WIN32)
      set(FORTRAN_NAMING "UPPERCASE" CACHE STRING ${FORTRAN_NAMING_HELP})
    else (WIN32)
      set(FORTRAN_NAMING "LOWERCASE_" CACHE STRING ${FORTRAN_NAMING_HELP})
    endif (WIN32)
    if (${CMAKE_MAJOR_VERSION} GREATER 2 OR ${CMAKE_MINOR_VERSION} GREATER 7)
      set_property(CACHE FORTRAN_NAMING PROPERTY STRINGS ${F2CLIST})
    endif (${CMAKE_MAJOR_VERSION} GREATER 2 OR ${CMAKE_MINOR_VERSION} GREATER 7)
  else (FORTRAN_NAMING STREQUAL "UNKNOWN")
    list(FIND F2CLIST "${FORTRAN_NAMING}" ListIndex)
    if (ListIndex LESS 0)
      message(SEND_ERROR "invalid FORTRAN_NAMING value. Must be empty or one of:
        LOWERCASE
        LOWERCASE_
        LOWERCASE__
        UPPERCASE
        UPPERRCASE_
        UPPERRCASE__")
    endif (ListIndex LESS 0)
  endif (FORTRAN_NAMING STREQUAL "UNKNOWN")
endif (ENABLE_FORTRAN)

# this forces cmake to set up the required Fortran variables
if (ENABLE_FORTRAN AND HAS_FORTRAN)
  enable_language("Fortran")
endif (ENABLE_FORTRAN AND HAS_FORTRAN)

########
# HDF5 #
########

option(ENABLE_HDF5 "Enable or disable HDF5 interface" "OFF")
if (ENABLE_HDF5)
  find_path(HDF5_INCLUDE_PATH hdf5.h)
  find_library(HDF5_LIBRARY hdf5)

  set(HDF5_NEED_ZLIB "OFF" CACHE BOOL "Does the HDF5 library require linking to zlib?")
  if(HDF5_NEED_ZLIB)
    find_library(ZLIB_LIBRARY z)
    mark_as_advanced(CLEAR ZLIB_LIBRARY)
  else (HDF5_NEED_ZLIB)
    mark_as_advanced(FORCE ZLIB_LIBRARY)
  endif(HDF5_NEED_ZLIB)

  set(HDF5_NEED_SZIP "OFF" CACHE BOOL "Does the HDF5 library require linking to zlib?")
  if (HDF5_NEED_SZIP)
    find_library(SZIP_LIBRARY szip)
    mark_as_advanced(CLEAR SZIP_LIBRARY)
  else (HDF5_NEED_SZIP)
    mark_as_advanced(FORCE SZIP_LIBRARY)
  endif (HDF5_NEED_SZIP)

  set(HDF5_NEED_MPI "OFF" CACHE BOOL "Does the HDF5 library require linking to mpi? (Only true if using parallel HDF5)")
  set(MPI_INC)
  set(MPI_LIBS)
  if (HDF5_NEED_MPI)
    if (NOT MPI_FOUND)
      include(FindMPI)
    endif (NOT MPI_FOUND)
    # MPI variable names changed with cmake 2.8.5
    if (DEFINED MPI_C_COMPILER)
      mark_as_advanced(CLEAR MPI_C_COMPILER MPI_C_INCLUDE_PATH MPI_C_LIBRARIES)
      mark_as_advanced(FORCE MPI_LIBRARY MPI_EXTRA_LIBRARY)
      set(MPI_INC ${MPI_C_INCLUDE_PATH})
      set(MPI_LIBS ${MPI_C_LIBRARIES})
    else (DEFINED MPI_C_COMPILER)
      mark_as_advanced(CLEAR MPI_COMPILER MPI_INCLUDE_PATH MPI_LIBRARY MPI_EXTRA_LIBRARY)
      set(MPI_INC ${MPI_INCLUDE_PATH})
      if (MPI_EXTRA_LIBRARY)
        set(MPI_LIBS ${MPI_LIBRARY} ${MPI_EXTRA_LIBRARY})
      else (MPI_EXTRA_LIBRARY)
        set(MPI_LIBS ${MPI_LIBRARY})
      endif (MPI_EXTRA_LIBRARY)
    endif (DEFINED MPI_C_COMPILER)
    if (ENABLE_TESTS AND ENABLE_PARALLEL)
      mark_as_advanced(CLEAR MPIEXEC)
    else (ENABLE_TESTS AND ENABLE_PARALLEL)
      mark_as_advanced(FORCE MPIEXEC)
    endif (ENABLE_TESTS AND ENABLE_PARALLEL)
  else (HDF5_NEED_MPI)
    mark_as_advanced(FORCE MPI_C_COMPILER MPI_C_INCLUDE_PATH MPI_C_LIBRARIES)
    mark_as_advanced(FORCE MPI_COMPILER MPI_INCLUDE_PATH MPI_LIBRARY MPI_EXTRA_LIBRARY MPIEXEC)
  endif (HDF5_NEED_MPI)
  mark_as_advanced(CLEAR HDF5_NEED_ZLIB HDF5_NEED_SZIP HDF5_NEED_MPI)
else (ENABLE_HDF5)
  mark_as_advanced(FORCE HDF5_NEED_ZLIB HDF5_NEED_SZIP HDF5_NEED_MPI)
  mark_as_advanced(FORCE HDF5_INCLUDE_PATH HDF5_LIBRARY)
  mark_as_advanced(FORCE ZLIB_LIBRARY SZIP_LIBRARY)
  mark_as_advanced(FORCE MPI_C_COMPILER MPI_C_INCLUDE_PATH MPI_C_LIBRARIES)
  mark_as_advanced(FORCE MPI_COMPILER MPI_INCLUDE_PATH MPI_LIBRARY MPI_EXTRA_LIBRARY MPIEXEC)
endif (ENABLE_HDF5)

#################
# parallel cgns #
#################

if (ENABLE_HDF5 AND HDF5_NEED_MPI)
  set(BUILD_PCGNS "OFF" CACHE BOOL "Build parallel CGNS ?")
  mark_as_advanced(CLEAR BUILD_PCGNS)
else (ENABLE_HDF5 AND HDF5_NEED_MPI)
  set(BUILD_PCGNS "OFF")
  mark_as_advanced(FORCE BUILD_PCGNS)
endif (ENABLE_HDF5 AND HDF5_NEED_MPI)

if (ENABLE_TESTS AND BUILD_PCGNS)
  mark_as_advanced(CLEAR MPIEXEC)
else (ENABLE_TESTS AND BUILD_PCGNS)
  mark_as_advanced(FORCE MPIEXEC)
endif (ENABLE_TESTS AND BUILD_PCGNS)

####################
# RPATH Management #
####################

# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

# the RPATH to be used when installing
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

########
# CGNS #
########

# Include the src directory
add_subdirectory(src)

#########
# PCGNS #
#########

if (BUILD_PCGNS)
  add_subdirectory(pcgns/src)
endif (BUILD_PCGNS)

=== pcgns/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  if (${CMAKE_MAJOR_VERSION} GREATER 2 OR ${CMAKE_MINOR_VERSION} GREATER 7)
    cmake_policy(SET CMP0015 OLD)
  endif (${CMAKE_MAJOR_VERSION} GREATER 2 OR ${CMAKE_MINOR_VERSION} GREATER 7)
endif(COMMAND cmake_policy)

set(CMAKE_BUILD_TYPE "Release" CACHE STRING
  "one of: Release, Debug, RelWithDebInfo or MinSizeRel")

project("pcgns")

# Allow for building a package
set(CPACK_PACKAGE_VERSION "0.2.0")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "pcgns")
set(CPACK_GENERATOR "STGZ;TGZ")
set(CPACK_SOURCE_GENERATOR "STGZ;TGZ")
include(CPack)

set(CGNS_BUILD_SHARED "ON" CACHE BOOL "Build a shared version of the library")
option(CGNS_USE_SHARED "Link programs to the CGNS shared library" "ON")

#########
# Tests #
#########

option(ENABLE_TESTS "Enable test programs" "OFF")
if (ENABLE_TESTS)
  enable_testing()
endif (ENABLE_TESTS)

########
# HDF5 #
########

# Setup the variables for HDF5
find_path(HDF5_INCLUDE_PATH hdf5.h)
find_library(HDF5_LIBRARY hdf5)

set(HDF5_NEED_ZLIB "OFF" CACHE BOOL "Does the HDF5 library require linking to zlib?")
if(HDF5_NEED_ZLIB)
  find_library(ZLIB_LIBRARY z)
endif(HDF5_NEED_ZLIB)

set(HDF5_NEED_SZIP "OFF" CACHE BOOL "Does the HDF5 library require linking to zlib?")
if (HDF5_NEED_SZIP)
  find_library(SZIP_LIBRARY szip)
endif (HDF5_NEED_SZIP)

#######
# MPI #
#######

include(FindMPI)
if (NOT MPI_FOUND)
  mark_as_advanced(CLEAR MPI_COMPILER)
endif (NOT MPI_FOUND)

if (ENABLE_TESTS AND NOT MPIEXEC)
  mark_as_advanced(CLEAR MPIEXEC)
endif (ENABLE_TESTS AND NOT MPIEXEC)

########
# CGNS #
########

# Include the src directory
add_subdirectory(src)

=== src/CMakeLists.txt ===

##########
# Global #
##########

if (WIN32)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif (WIN32)

# Include the local directory
include_directories(.)
if (ENABLE_HDF5)
  add_definitions(-DBUILD_HDF5)
  if (WIN32)
    if (HDF5_LIBRARY)
      file(STRINGS ${HDF5_LIBRARY} HDF5isDLL REGEX "__imp__H5close")
      if (HDF5isDLL)
        # this is only needed when using hdf5 dll libs
        add_definitions(-DWIN32 -D_HDF5USEDLL_)
      endif (HDF5isDLL)
    endif (HDF5_LIBRARY)
  endif (WIN32)
  # Includes from HDF5
  if (HDF5_INCLUDE_PATH)
    include_directories(${HDF5_INCLUDE_PATH})
  endif (HDF5_INCLUDE_PATH)
  if(HDF5_NEED_MPI AND MPI_INC)
    include_directories(${MPI_INC})
  endif(HDF5_NEED_MPI AND MPI_INC)
endif (ENABLE_HDF5)

################################
# create configed header files #
################################

if (${SIZE_OF_LONG} GREATER 4)
  set(CGLONGT long)
else (${SIZE_OF_LONG} GREATER 4)
  set(CGLONGT "long long")
endif (${SIZE_OF_LONG} GREATER 4)

set(BUILDLEGACY 0)
set(BUILD64BIT 0)
set(BUILDSCOPE 0)

if (ENABLE_LEGACY)
  set(BUILDLEGACY 1)
  set(CGFSIZET "")
else (ENABLE_LEGACY)
  if (ENABLE_64BIT)
    set(BUILD64BIT 1)
    set(CGFSIZET *8)
  else (ENABLE_64BIT)
    set(CGFSIZET *4)
  endif (ENABLE_64BIT)
endif (ENABLE_LEGACY)

if (ENABLE_SCOPING)
  set(BUILDSCOPE 1)
endif (ENABLE_SCOPING)

#create these in build directory so is doesn't mess up the
#source directory, then add the path to them
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/cgnstypes.h.in
		${CMAKE_CURRENT_BINARY_DIR}/cgnstypes.h )
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/cgnstypes_f.h.in
		${CMAKE_CURRENT_BINARY_DIR}/cgnstypes_f.h )
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/cgnslib_f.h.in
		${CMAKE_CURRENT_BINARY_DIR}/cgnslib_f.h )

include_directories(${CMAKE_CURRENT_BINARY_DIR})

######################################################
# configure for cgnsBuild.defs file for installation #
######################################################

set(SYSCFLAGS)
set(CFGFLAGS)
set(LIBS)
if (ENABLE_FORTRAN)
  set(BUILDFORTRAN 1)
else (ENABLE_FORTRAN)
  set(BUILDFORTRAN 0)
endif (ENABLE_FORTRAN)

file(TO_NATIVE_PATH ${CMAKE_INSTALL_PREFIX}/lib LIBDIR)
file(TO_NATIVE_PATH ${CMAKE_INSTALL_PREFIX}/include INCLUDEDIR)
file(TO_NATIVE_PATH ${CMAKE_C_COMPILER} CC)
if (WIN32)
  set(CGNSLIB cgns.lib)
else (WIN32)
  set(CGNSLIB libcgns.a)
  set(LIBS -lm)
endif (WIN32)

string(COMPARE EQUAL ${CMAKE_BUILD_TYPE} Debug IS_DEBUG)
if (IS_DEBUG)
  set(BUILDDEBUG 1)
  set(CFLAGS ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_DEBUG})
  set(LDFLAGS ${CMAKE_EXE_LINKER_FLAGS} ${CMAKE_EXE_LINKER_FLAGS_DEBUG})
else (IS_DEBUG)
  set(BUILDDEBUG 0)
  set(CFLAGS ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_RELEASE})
  set(LDFLAGS ${CMAKE_EXE_LINKER_FLAGS} ${CMAKE_EXE_LINKER_FLAGS_RELEASE})
endif (IS_DEBUG)

set(HDF5INC)
set(HDF5LIB)
set(SZIPLIB)
set(ZLIBLIB)
set(MPIINC)
set(MPILIBS)

macro(native_paths INPUT_PATH_VARIABLE RESULT_VARIABLE)
  set(${RESULT_VARIABLE} "")
  foreach(PATH ${${INPUT_PATH_VARIABLE}})
    file(TO_NATIVE_PATH ${PATH} NATIVE_PATH)
    list(APPEND ${RESULT_VARIABLE} ${NATIVE_PATH})
  endforeach(PATH ${${INPUT_PATH_VARIABLE}})
endmacro(native_paths)

if (ENABLE_HDF5)
  if (HDF5_INCLUDE_PATH)
    native_paths(HDF5_INCLUDE_PATH HDF5INC)
  endif (HDF5_INCLUDE_PATH)
  if (HDF5_LIBRARY)
    native_paths(HDF5_LIBRARY HDF5LIB)
  endif (HDF5_LIBRARY)
  if (HDF5_NEED_SZIP AND SZIP_LIBRARY)
    native_paths(SZIP_LIBRARY SZIPLIB)
  endif (HDF5_NEED_SZIP AND SZIP_LIBRARY)
  if (HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
    native_paths(ZLIB_LIBRARY ZLIBLIB)
  endif (HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
  if (HDF5_NEED_MPI)
    if (MPI_INC)
      native_paths(MPI_INC MPIINC)
    endif (MPI_INC)
    if (MPI_LIBS)
      native_paths(MPI_LIBS MPILIBS)
    endif (MPI_LIBS)
  endif (HDF5_NEED_MPI)
endif (ENABLE_HDF5)

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/cgnsBuild.defs.in
		${CMAKE_CURRENT_BINARY_DIR}/cgnsBuild.defs )

###########
# Library #
###########

# All the C files needed by the cgns library
set(cgns_C_FILES
	cgns_error.c
	cgns_internals.c
	cgns_io.c
	cgnslib.c
	adf/ADF_interface.c
	adf/ADF_internals.c)

# All the Fortran files need by the cgns library (if enabled)
set(cgns_F_FILES
	cg_ftoc.c
	cgio_ftoc.c)

# Only build those files that are needed
if (ENABLE_FORTRAN)
  if (FORTRAN_NAMING)
    set_property(SOURCE ${cgns_F_FILES}
      PROPERTY COMPILE_DEFINITIONS ${FORTRAN_NAMING})
  endif (FORTRAN_NAMING)
  if (ENABLE_HDF5)
    set(cgns_FILES ${cgns_C_FILES} adfh/ADFH.c ${cgns_F_FILES})
  else (ENABLE_HDF5)
    set(cgns_FILES ${cgns_C_FILES} ${cgns_F_FILES})
  endif (ENABLE_HDF5)
else (ENABLE_FORTRAN)
  if (ENABLE_HDF5)
    set(cgns_FILES ${cgns_C_FILES} adfh/ADFH.c)
  else (ENABLE_HDF5)
    set(cgns_FILES ${cgns_C_FILES})
  endif (ENABLE_HDF5)
endif (ENABLE_FORTRAN)

set(CGNS_BUILD_SHARED "ON" CACHE BOOL "Build a shared version of the library")
option(CGNS_USE_SHARED "Link programs to the CGNS shared library" "ON")

# Build a static version of the library
add_library(cgns_static STATIC ${cgns_FILES})

# Build a shared version of the library
if(CGNS_BUILD_SHARED)
  mark_as_advanced(CLEAR CGNS_USE_SHARED)
  add_library(cgns_shared SHARED ${cgns_FILES})
  # under windows we need to define BUILD_DLL
  # and link with the HDF5 libraries to build a dll
  if (WIN32 OR CYGWIN)
    add_definitions(-DBUILD_DLL)
    if (ENABLE_HDF5 AND HDF5_LIBRARY)
      target_link_libraries(cgns_shared ${HDF5_LIBRARY})
      if(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
        target_link_libraries(cgns_shared ${ZLIB_LIBRARY})
      endif(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
      if(HDF5_NEED_SZIP AND SZIP_LIBRARY)
        target_link_libraries(cgns_shared ${SZIP_LIBRARY})
      endif(HDF5_NEED_SZIP AND SZIP_LIBRARY)
      if(HDF5_NEED_MPI AND MPI_LIBS)
        target_link_libraries(cgns_shared ${MPI_LIBS})
      endif(HDF5_NEED_MPI AND MPI_LIBS)
    endif (ENABLE_HDF5 AND HDF5_LIBRARY)
  endif (WIN32 OR CYGWIN)
else(CGNS_BUILD_SHARED)
  set(CGNS_USE_SHARED "OFF")
  mark_as_advanced(FORCE CGNS_USE_SHARED)
endif(CGNS_BUILD_SHARED)

# Change the output name of the library to be libcgns
set_target_properties(cgns_static PROPERTIES OUTPUT_NAME cgns)
set_target_properties(cgns_static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
if(CGNS_BUILD_SHARED)
  # for windows we need to change the name of the shared library
  # for both static and shared version to exist
  if (WIN32 OR CYGWIN)
    set_target_properties(cgns_shared PROPERTIES OUTPUT_NAME cgnsdll)
  else (WIN32 OR CYGWIN)
    set_target_properties(cgns_shared PROPERTIES OUTPUT_NAME cgns)
  endif (WIN32 OR CYGWIN)
  set_target_properties(cgns_shared PROPERTIES CLEAN_DIRECT_OUTPUT 1)
endif(CGNS_BUILD_SHARED)

# Set the version numbers
set_target_properties(cgns_static PROPERTIES VERSION ${CGNS_VERSION})
set_target_properties(cgns_static PROPERTIES SOVERSION ${CGNS_VERSION})

if(CGNS_BUILD_SHARED)
  set_target_properties(cgns_shared PROPERTIES VERSION ${CGNS_VERSION})
  set_target_properties(cgns_shared PROPERTIES SOVERSION ${CGNS_VERSION})
endif(CGNS_BUILD_SHARED)

# Set the install path of the static library
install(TARGETS cgns_static ARCHIVE DESTINATION lib)
# Set the install path of the shared library
if(CGNS_BUILD_SHARED)
  # for windows, need to install both cgnsdll.dll and cgnsdll.lib
  if (WIN32 OR CYGWIN)
    install(TARGETS cgns_shared ARCHIVE DESTINATION lib)
    install(TARGETS cgns_shared RUNTIME DESTINATION lib)
  else (WIN32 OR CYGWIN)
    install(TARGETS cgns_shared LIBRARY DESTINATION lib)
  endif (WIN32 OR CYGWIN)
endif(CGNS_BUILD_SHARED)

# Set the install path of the header files
install(FILES
	cgnslib.h
	cgns_io.h
	cgnswin_f.h
	${CMAKE_CURRENT_BINARY_DIR}/cgnstypes.h
	${CMAKE_CURRENT_BINARY_DIR}/cgnstypes_f.h
	${CMAKE_CURRENT_BINARY_DIR}/cgnslib_f.h
	${CMAKE_CURRENT_BINARY_DIR}/cgnsBuild.defs
	DESTINATION include)

if (ENABLE_LEGACY)
  install(FILES adf/ADF.h DESTINATION include/adf)
  if (ENABLE_HDF5)
    install(FILES adfh/ADFH.h DESTINATION include/adfh)
  endif (ENABLE_HDF5)
endif (ENABLE_LEGACY)

#########
# Tools #
#########

add_subdirectory(tools)

#########
# Tests #
#########

if (ENABLE_TESTS)
  add_subdirectory(tests)
endif (ENABLE_TESTS)

##############
# CGNS Tools #
##############


set(BUILD_CGNSTOOLS "OFF" CACHE BOOL "Build the CGNSTools package")
if(BUILD_CGNSTOOLS)
	add_subdirectory(cgnstools)
endif(BUILD_CGNSTOOLS)

=== pcgns/src/CMakeLists.txt ===
##########
# Global #
##########

# Include directories
include_directories(. ${HDF5_INCLUDE_PATH} ${MPI_INCLUDE_PATH})

###########
# Library #
###########

# All the files needed by the cgns library
set(pcgns_FILES
	pcgnslib.c
	pcgns_util.c)

# Build a static version of the library
add_library(pcgns_static STATIC ${pcgns_FILES})
set_target_properties(pcgns_static PROPERTIES OUTPUT_NAME pcgns)
set_target_properties(pcgns_static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
set_target_properties(pcgns_static PROPERTIES VERSION "0.2")
set_target_properties(pcgns_static PROPERTIES SOVERSION "0.2")

# Build a shared version of the library
if(CGNS_BUILD_SHARED)
  mark_as_advanced(CLEAR CGNS_USE_SHARED)
  add_library(pcgns_shared SHARED ${pcgns_FILES})
  # under windows we need to link with the HDF5 and MPI libraries
  # to build a dll and change the name of the shared library
  # for both static and shared version to exist
  if (WIN32 OR CYGWIN)
    target_link_libraries(pcgns_shared ${HDF5_LIBRARY})
    if(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
      target_link_libraries(pcgns_shared ${ZLIB_LIBRARY})
    endif(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
    if(HDF5_NEED_SZIP AND SZIP_LIBRARY)
      target_link_libraries(pcgns_shared ${SZIP_LIBRARY})
    endif(HDF5_NEED_SZIP AND SZIP_LIBRARY)
    if(MPI_LIBRARY)
      target_link_libraries(pcgns_shared ${MPI_LIBRARY})
    endif(MPI_LIBRARY)
    set_target_properties(pcgns_shared PROPERTIES OUTPUT_NAME pcgnsdll)
  else (WIN32 OR CYGWIN)
    set_target_properties(pcgns_shared PROPERTIES OUTPUT_NAME pcgns)
  endif (WIN32 OR CYGWIN)
  set_target_properties(pcgns_shared PROPERTIES CLEAN_DIRECT_OUTPUT 1)
  set_target_properties(pcgns_shared PROPERTIES VERSION "0.2")
  set_target_properties(pcgns_shared PROPERTIES SOVERSION "0.2")
else(CGNS_BUILD_SHARED)
  set(CGNS_USE_SHARED "OFF")
  mark_as_advanced(FORCE CGNS_USE_SHARED)
endif(CGNS_BUILD_SHARED)

# Set the install path of the static library
install(TARGETS pcgns_static ARCHIVE DESTINATION lib)

# Set the install path of the shared library
if(CGNS_BUILD_SHARED)
  # for windows, need to install both cgnsdll.dll and cgnsdll.lib
  if (WIN32 OR CYGWIN)
    install(TARGETS pcgns_shared ARCHIVE DESTINATION lib)
    install(TARGETS pcgns_shared RUNTIME DESTINATION lib)
  else (WIN32 OR CYGWIN)
    install(TARGETS pcgns_shared LIBRARY DESTINATION lib)
  endif (WIN32 OR CYGWIN)
endif(CGNS_BUILD_SHARED)

# Set the install path of the header files
install(FILES
	pcgnslib.h
	DESTINATION include)

#########
# Tests #
#########

if (ENABLE_TESTS)
  add_subdirectory(tests)
endif (ENABLE_TESTS)

=== src/tests/CMakeLists.txt ===
#########
# Tests #
#########

# Link all the executables to cgns and hdf5
link_directories(.)
link_libraries(cgns_static)

if (ENABLE_HDF5 AND HDF5_LIBRARY)
  link_libraries(${HDF5_LIBRARY})
  if(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
    link_libraries(${ZLIB_LIBRARY})
  endif(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
  if(HDF5_NEED_SZIP AND SZIP_LIBRARY)
    link_libraries(${SZIP_LIBRARY})
  endif(HDF5_NEED_SZIP AND SZIP_LIBRARY)
  if(HDF5_NEED_MPI AND MPI_LIBS)
    link_libraries(${MPI_LIBS})
  endif(HDF5_NEED_MPI AND MPI_LIBS)
endif (ENABLE_HDF5 AND HDF5_LIBRARY)

if (NOT WIN32)
  link_libraries(m)
endif (NOT WIN32)

# Set the files needed by each test
set(cgioc_FILES cgioc.c)
set(dbtest_FILES dbtest.c utils.c)
set(elemtest_FILES elemtest.c)
set(open_cgns_FILES open_cgns.c utils.c)
set(test_exts_FILES test_exts.c)
set(test_goto_FILES test_goto.c)
set(test_partial_FILES test_partial.c)
set(test_ver31_FILES test_ver31.c)
set(write_array_FILES write_array.c utils.c)
set(write_bcdata_FILES write_bcdata.c utils.c)
set(write_links_FILES write_links.c utils.c)
set(write_rind_FILES write_rind.c)
set(write_test_FILES write_test.c)
set(write_zones_FILES write_zones.c utils.c)
set(cgiof_FILES cgiof.F)
set(cgread_FILES cgread.F)
set(cgwrite_FILES cgwrite.F)
set(cgzconn_FILES cgzconn.F)
set(cgsubreg_FILES cgsubreg.F)
set(f2c_test_FILES ../f2c/fmain.f ../f2c/csub.c)

# Build each test
add_executable( cgioc        ${cgioc_FILES}        )
add_executable( dbtest       ${dbtest_FILES}       )
add_executable( elemtest     ${elemtest_FILES}     )
add_executable( open_cgns    ${open_cgns_FILES}    )
add_executable( test_exts    ${test_exts_FILES}    )
add_executable( test_goto    ${test_goto_FILES}    )
add_executable( test_partial ${test_partial_FILES} )
add_executable( test_ver31   ${test_ver31_FILES}   )
add_executable( write_array  ${write_array_FILES}  )
add_executable( write_bcdata ${write_bcdata_FILES} )
add_executable( write_links  ${write_links_FILES}  )
add_executable( write_rind   ${write_rind_FILES}   )
add_executable( write_test   ${write_test_FILES}   )
add_executable( write_zones  ${write_zones_FILES}  )

# Conditionally build the fortran tests
if (ENABLE_FORTRAN AND HAS_FORTRAN)
	add_executable( f2c_test     ${f2c_test_FILES} )
	add_executable( cgread       ${cgread_FILES}   )
	add_executable( cgwrite      ${cgwrite_FILES}  )
	add_executable( cgzconn      ${cgzconn_FILES}  )
	add_executable( cgsubreg     ${cgsubreg_FILES} )
	if (NOT ENABLE_64BIT)
	  add_executable(cgiof ${cgiof_FILES})
	endif (NOT ENABLE_64BIT)
endif (ENABLE_FORTRAN AND HAS_FORTRAN)

# Add the tests so that ctest can find them
if (ENABLE_TESTS)
  add_test( cgioc        cgioc                    )
#  add_test( dbtest       dbtest 1 1 elemtest.cgns )
  add_test( elemtest     elemtest                 )
#  add_test( open_cgns    open_cgns elemtest.cgns  )
  add_test( test_exts    test_exts                )
  add_test( test_goto    test_goto                )
  add_test( test_partial test_partial             )
  add_test( test_ver31   test_ver31               )
  add_test( write_array  write_array              )
  add_test( write_bcdata write_bcdata             )
  add_test( write_links  write_links              )
  add_test( write_rind   write_rind               )
  add_test( write_test   write_test               )
  add_test( write_zones  write_zones              )

  # Conditionally add the fortran tests
  if (ENABLE_FORTRAN AND HAS_FORTRAN)
	add_test( f2c_test f2c_test ) # This still needs a regex test
	add_test( cgwrite  cgwrite  )
	add_test( cgread   cgread   )
	add_test( cgzconn  cgzconn  )
	add_test( cgsubreg cgsubreg )
	if (NOT ENABLE_64BIT)
	  add_test(cgiof cgiof)
	endif (NOT ENABLE_64BIT)
  endif (ENABLE_FORTRAN AND HAS_FORTRAN)
endif (ENABLE_TESTS)

=== src/tools/CMakeLists.txt ===
#########
# Tools #
#########

# Link all the executables to cgns and hdf5
link_directories(.)
if (CGNS_USE_SHARED)
  link_libraries(cgns_shared)
else (CGNS_USE_SHARED)
  link_libraries(cgns_static)
endif (CGNS_USE_SHARED)

if (ENABLE_HDF5 AND HDF5_LIBRARY)
  link_libraries(${HDF5_LIBRARY})
  if(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
    link_libraries(${ZLIB_LIBRARY})
  endif(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
  if(HDF5_NEED_SZIP AND SZIP_LIBRARY)
    link_libraries(${SZIP_LIBRARY})
  endif(HDF5_NEED_SZIP AND SZIP_LIBRARY)
  if(HDF5_NEED_MPI AND MPI_LIBS)
    link_libraries(${MPI_LIBS})
  endif(HDF5_NEED_MPI AND MPI_LIBS)
endif (ENABLE_HDF5 AND HDF5_LIBRARY)

if (NOT WIN32)
  link_libraries(m)
endif (NOT WIN32)

# Set the files needed by each tool
set(cgnsnames_FILES
	cgnsnames.c
	cgnames.c)
set(cgnscheck_FILES
	cgnscheck.c
	getargs.c
	hash.c
	cgnames.c)
set(cgnsconvert_FILES
	cgnsconvert.c
	getargs.c)
set(cgnsdiff_FILES
	cgnsdiff.c
	getargs.c)
set(cgnslist_FILES
	cgnslist.c
	getargs.c)
set(cgnscompress_FILES
	cgnscompress.c)
set(cgnsversion_FILES
	cgnsversion.c
	getargs.c)
set(cgnsreplace_FILES
	cgnsreplace.c)

# Build each tool
add_executable( cgnsnames    ${cgnsnames_FILES}   )
add_executable( cgnscheck    ${cgnscheck_FILES}   )
add_executable( cgnsconvert  ${cgnsconvert_FILES} )
add_executable( cgnsdiff     ${cgnsdiff_FILES}    )
add_executable( cgnslist     ${cgnslist_FILES}    )
add_executable( cgnscompress ${cgnscompress_FILES})
add_executable( cgnsversion  ${cgnsversion_FILES} )
add_executable( cgnsreplace  ${cgnsreplace_FILES} )

install(TARGETS
	cgnsnames
	cgnscheck
	cgnsconvert
	cgnsdiff
	cgnslist
        cgnscompress
	cgnsversion
	cgnsreplace
	RUNTIME DESTINATION bin)

if (WIN32)
  install(PROGRAMS
        cgnsupdate.bat
	DESTINATION bin)
  # lets also put the dll in here so they run
  if (CGNS_USE_SHARED)
    install(PROGRAMS
        ${CMAKE_BINARY_DIR}/src/cgnsdll.dll
	DESTINATION bin)
  endif (CGNS_USE_SHARED)
  if (ENABLE_HDF5)
    install(PROGRAMS
        adf2hdf.bat
        hdf2adf.bat
	DESTINATION bin)
  endif (ENABLE_HDF5)
else (WIN32)
  install(PROGRAMS
        cgnsupdate
	DESTINATION bin)
  if (ENABLE_HDF5)
    install(PROGRAMS
        adf2hdf
        hdf2adf
	DESTINATION bin)
  endif (ENABLE_HDF5)
endif (WIN32)

=== pcgns/src/tests/CMakeLists.txt ===
#########
# Tests #
#########

if (NOT MPIEXEC)
  message(SEND_ERROR "need to define MPIEXEC to run tests")
endif (NOT MPIEXEC)

# Link all the executables to cgns and hdf5
if (CGNS_BUILD_SHARED AND CGNS_USE_SHARED)
  link_libraries(pcgns_shared)
else (CGNS_BUILD_SHARED AND CGNS_USE_SHARED)
  link_libraries(pcgns_static)
endif (CGNS_BUILD_SHARED AND CGNS_USE_SHARED)
link_libraries(${HDF5_LIBRARY})
link_libraries(${MPI_LIBRARY})
if (MPI_EXTRA_LIBRARY)
  link_libraries(${MPI_EXTRA_LIBRARY})
endif (MPI_EXTRA_LIBRARY)
if (HDF5_NEED_ZLIB)
  link_libraries(${ZLIB_LIBRARY}) 
endif (HDF5_NEED_ZLIB)
if (HDF5_NEED_SZIP)
  link_libraries(${SZIP_LIBRARY}) 
endif (HDF5_NEED_SZIP)
if (NOT WIN32)
  link_libraries(m)
endif (NOT WIN32)

set(benchmark_FILES
	benchmark.c)
add_executable(benchmark ${benchmark_FILES})
add_test(benchmark ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} "2"
         ${MPIEXEC_PREFLAGS} benchmark ${MPIEXEC_POSTFLAGS})

set(open_close_FILES
	open_close.c)
add_executable(open_close ${open_close_FILES})
add_test(open_close ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} "2"
         ${MPIEXEC_PREFLAGS} open_close ${MPIEXEC_POSTFLAGS})

set(test_base_FILES
	test_base.c)
add_executable(test_base ${test_base_FILES})
add_test(test_base ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} "2"
         ${MPIEXEC_PREFLAGS} test_base ${MPIEXEC_POSTFLAGS})

set(test_zone_FILES
	test_zone.c)
add_executable(test_zone ${test_zone_FILES})
add_test(test_zone ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} "2"
         ${MPIEXEC_PREFLAGS} test_zone ${MPIEXEC_POSTFLAGS})

set(test_unstructured_FILES
	test_unstructured.c)
add_executable(test_unstructured ${test_unstructured_FILES})
add_test(test_unstructured ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} "2"
         ${MPIEXEC_PREFLAGS} test_unstructured ${MPIEXEC_POSTFLAGS})

set(test_queue_FILES
	test_queue.c)
add_executable(test_queue ${test_queue_FILES})
add_test(test_queue ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} "2"
         ${MPIEXEC_PREFLAGS} test_queue ${MPIEXEC_POSTFLAGS})

set(thesis_benchmark_FILES
	thesis_benchmark.c)
add_executable(thesis_benchmark ${thesis_benchmark_FILES})
add_test(thesis_benchmark ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} "2"
         ${MPIEXEC_PREFLAGS} thesis_benchmark ${MPIEXEC_POSTFLAGS}
         -ds 1.0 -zpp 2 -ppz 2)

=== src/cgnstools/cgnscalc/CMakeLists.txt ===
############
# cgnscalc #
############

include_directories(${TCL_INCLUDE_PATH} ${TK_INCLUDE_PATH})
include_directories(../calclib)
link_directories(.)
if (CGNS_USE_SHARED)
  link_libraries(cgns_shared)
else (CGNS_USE_SHARED)
  link_libraries(cgns_static)
endif (CGNS_USE_SHARED)
link_libraries(calclib ${TCL_LIBRARY} ${TK_LIBRARY})

if (ENABLE_HDF5 AND HDF5_LIBRARY)
  link_libraries(${HDF5_LIBRARY})
  if(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
    link_libraries(${ZLIB_LIBRARY})
  endif(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
  if(HDF5_NEED_SZIP AND SZIP_LIBRARY)
    link_libraries(${SZIP_LIBRARY})
  endif(HDF5_NEED_SZIP AND SZIP_LIBRARY)
  if(HDF5_NEED_MPI AND MPI_LIBS)
    link_libraries(${MPI_LIBS})
  endif(HDF5_NEED_MPI AND MPI_LIBS)
endif (ENABLE_HDF5 AND HDF5_LIBRARY)

if (WIN32)
  if (HTML_HELP_INCLUDE_PATH AND HTML_HELP_LIBRARY)
    add_definitions(-DUSE_HTMLHELP)
    include_directories(${HTML_HELP_INCLUDE_PATH})
    link_libraries(${HTML_HELP_LIBRARY})
    set(cgnscalc_FILES calctcl.c winmain.c ../common/winhtml.c)
  else (HTML_HELP_INCLUDE_PATH AND HTML_HELP_LIBRARY)
    set(cgnscalc_FILES calctcl.c winmain.c)
  endif (HTML_HELP_INCLUDE_PATH AND HTML_HELP_LIBRARY)
else (WIN32)
  include_directories(${X11_X11_INCLUDE_PATH})
  link_libraries(${X11_X11_LIB} m)
  set(cgnscalc_FILES
	calctcl.c
	calcwish.c)
endif (WIN32)

add_executable(calcwish ${cgnscalc_FILES})
add_dependencies(calcwish calclib cgns_static)

if (WIN32)
  set_target_properties(calcwish PROPERTIES
  	LINK_FLAGS /subsystem:windows)
endif (WIN32)

if (WIN32)
  install(TARGETS
	calcwish
	RUNTIME DESTINATION bin)
  install(PROGRAMS
	cgnscalc.bat
	unitconv.bat
	DESTINATION bin)
  install(FILES
	cgnscalc.tcl
	unitconv.tcl
	cgnscalc.ico
	cgnscalc.png
	cgnscalc-icon.xbm
	cgnscalc-mask.xbm
	unitconv.ico
	unitconv.png
	unitconv.xbm
	DESTINATION share)
else (WIN32)
  install(TARGETS
	calcwish
	RUNTIME DESTINATION bin/cgnstools)
  install(PROGRAMS
	cgnscalc.sh
	DESTINATION bin
	RENAME cgnscalc)
  install(PROGRAMS
	unitconv.sh
	DESTINATION bin
	RENAME unitconv)
  install(FILES
	cgnscalc.tcl
	unitconv.tcl
	cgnscalc.ico
	cgnscalc.png
	cgnscalc-icon.xbm
	cgnscalc-mask.xbm
	unitconv.ico
	unitconv.png
	unitconv.xbm
	DESTINATION share/cgnstools)
endif (WIN32)

=== src/cgnstools/cgnsplot/CMakeLists.txt ===
############
# cgnsplot #
############

include_directories(${TCL_INCLUDE_PATH} ${TK_INCLUDE_PATH} ${OPENGL_INCLUDE_DIR})
include_directories(../common)
link_directories(. ../tkogl)
if (CGNS_USE_SHARED)
  link_libraries(cgns_shared)
else (CGNS_USE_SHARED)
  link_libraries(cgns_static)
endif (CGNS_USE_SHARED)
link_libraries(tkogl ${TCL_LIBRARY} ${TK_LIBRARY}
	${OPENGL_gl_LIBRARY} ${OPENGL_glu_LIBRARY})

if (ENABLE_HDF5 AND HDF5_LIBRARY)
  link_libraries(${HDF5_LIBRARY})
  if(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
    link_libraries(${ZLIB_LIBRARY})
  endif(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
  if(HDF5_NEED_SZIP AND SZIP_LIBRARY)
    link_libraries(${SZIP_LIBRARY})
  endif(HDF5_NEED_SZIP AND SZIP_LIBRARY)
  if(HDF5_NEED_MPI AND MPI_LIBS)
    link_libraries(${MPI_LIBS})
  endif(HDF5_NEED_MPI AND MPI_LIBS)
endif (ENABLE_HDF5 AND HDF5_LIBRARY)

if (WIN32)
  if (HTML_HELP_INCLUDE_PATH AND HTML_HELP_LIBRARY)
    add_definitions(-DUSE_HTMLHELP)
    include_directories(${HTML_HELP_INCLUDE_PATH})
    link_libraries(${HTML_HELP_LIBRARY})
    set(cgnsplot_FILES cgnstcl.c winmain.c ../common/hash.c ../common/winhtml.c)
  else (HTML_HELP_INCLUDE_PATH AND HTML_HELP_LIBRARY)
    set(cgnsplot_FILES cgnstcl.c winmain.c ../common/hash.c)
  endif (HTML_HELP_INCLUDE_PATH AND HTML_HELP_LIBRARY)
else (WIN32)
  include_directories(${X11_X11_INCLUDE_PATH})
  link_libraries(${X11_X11_LIB} ${X11_Xmu_LIB} m)
  set(cgnsplot_FILES
	cgnstcl.c
	plotwish.c
	../common/hash.c)
endif (WIN32)

add_executable(plotwish ${cgnsplot_FILES})
add_dependencies(plotwish cgns_static tkogl)

if (WIN32)
  set_target_properties(plotwish PROPERTIES
  	LINK_FLAGS /subsystem:windows)
endif (WIN32)

if (WIN32)
  install(TARGETS
	plotwish
	RUNTIME DESTINATION bin)
  install(PROGRAMS
	cgnsplot.bat
	DESTINATION bin)
  install(FILES
	cgnsplot.tcl
	cgnsplot.ico
	cgnsplot.png
	cgnsplot-icon.xbm
	cgnsplot-mask.xbm
	DESTINATION share)
else (WIN32)
  install(TARGETS
	plotwish
	RUNTIME DESTINATION bin/cgnstools)
  install(PROGRAMS
	cgnsplot.sh
	DESTINATION bin
	RENAME cgnsplot)
  install(FILES
	cgnsplot.tcl
	cgnsplot.ico
	cgnsplot.png
	cgnsplot-icon.xbm
	cgnsplot-mask.xbm
	DESTINATION share/cgnstools)
endif (WIN32)

=== src/cgnstools/cgnsview/CMakeLists.txt ===
#############
# cgnsview  #
#############

include_directories(${TCL_INCLUDE_PATH} ${TK_INCLUDE_PATH})
include_directories(../common)
include_directories(../..)
link_directories(.)
if (CGNS_USE_SHARED)
  link_libraries(cgns_shared)
else (CGNS_USE_SHARED)
  link_libraries(cgns_static)
endif (CGNS_USE_SHARED)
link_libraries(${TCL_LIBRARY} ${TK_LIBRARY})

if (ENABLE_HDF5 AND HDF5_LIBRARY)
  link_libraries(${HDF5_LIBRARY})
  if(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
    link_libraries(${ZLIB_LIBRARY})
  endif(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
  if(HDF5_NEED_SZIP AND SZIP_LIBRARY)
    link_libraries(${SZIP_LIBRARY})
  endif(HDF5_NEED_SZIP AND SZIP_LIBRARY)
  if(HDF5_NEED_MPI AND MPI_LIBS)
    link_libraries(${MPI_LIBS})
  endif(HDF5_NEED_MPI AND MPI_LIBS)
endif (ENABLE_HDF5 AND HDF5_LIBRARY)

if (WIN32)
  if (HTML_HELP_INCLUDE_PATH AND HTML_HELP_LIBRARY)
    add_definitions(-DUSE_HTMLHELP)
    include_directories(${HTML_HELP_INCLUDE_PATH})
    link_libraries(${HTML_HELP_LIBRARY})
    set(cgnsview_FILES cgiotcl.c winmain.c ../common/winhtml.c)
  else (HTML_HELP_INCLUDE_PATH AND HTML_HELP_LIBRARY)
    set(cgnsview_FILES cgiotcl.c winmain.c)
  endif (HTML_HELP_INCLUDE_PATH AND HTML_HELP_LIBRARY)
else (WIN32)
  include_directories(${X11_X11_INCLUDE_PATH})
  link_libraries(${X11_X11_LIB} m)
  set(cgnsview_FILES
	cgiowish.c
	cgiotcl.c)
endif (WIN32)


add_executable(cgiowish ${cgnsview_FILES})
add_dependencies(cgiowish cgns_static)

if (WIN32)
  set_target_properties(cgiowish PROPERTIES
  	LINK_FLAGS /subsystem:windows)
endif (WIN32)

if (WIN32)
  install(TARGETS
	cgiowish
	RUNTIME DESTINATION bin)
  install(PROGRAMS
	cgnsview.bat
	cgnsnodes.bat
	DESTINATION bin)
  install(FILES
	cgnsview.tcl
	cgns.tcl
	cgnsnodes.tcl
	export.tcl
	import.tcl
	tools.tcl
	DESTINATION share)
else (WIN32)
  install(TARGETS
	cgiowish
	RUNTIME DESTINATION bin/cgnstools)
  install(PROGRAMS
	cgnsview.sh
	DESTINATION bin
	RENAME cgnsview)
  install(PROGRAMS
	cgnsnodes.sh
	DESTINATION bin
	RENAME cgnsnodes)
  install(FILES
	cgnsview.tcl
	cgns.tcl
	cgnsnodes.tcl
	export.tcl
	import.tcl
	tools.tcl
	DESTINATION share/cgnstools)
endif (WIN32)

=== src/cgnstools/common/CMakeLists.txt ===
##########
# common #
##########

if (WIN32)
  install(FILES
	balloon.tcl
	color.tcl
	combobox.tcl
	config.tcl
	dialog.tcl
	editfile.tcl
	filesel.tcl
	findfile.tcl
	frame.tcl
	help.tcl
	menubar.tcl
	tclIndex
	tclreg.tcl
	tkdir.tcl
	tree.tcl
	units.tcl
	cgns.ico
	cgns.png
	cgns-icon.xbm
	cgns-mask.xbm
	DESTINATION share)
else (WIN32)
  install(FILES
	balloon.tcl
	color.tcl
	combobox.tcl
	config.tcl
	dialog.tcl
	editfile.tcl
	filesel.tcl
	findfile.tcl
	frame.tcl
	help.tcl
	menubar.tcl
	tclIndex
	tclreg.tcl
	tkdir.tcl
	tree.tcl
	units.tcl
	cgns.ico
	cgns.png
	cgns-icon.xbm
	cgns-mask.xbm
	DESTINATION share/cgnstools)
endif (WIN32)

=== src/cgnstools/utilities/CMakeLists.txt ===
#############
# utilities #
#############

include_directories(../..)
include_directories(../calclib)
include_directories(../common)

# cgns_info
link_directories(.)
if (CGNS_USE_SHARED)
  link_libraries(cgns_shared)
else (CGNS_USE_SHARED)
  link_libraries(cgns_static)
endif (CGNS_USE_SHARED)
link_libraries(calclib)
if (NOT WIN32)
  link_libraries(m)
endif (NOT WIN32)

if (ENABLE_HDF5 AND HDF5_LIBRARY)
  link_libraries(${HDF5_LIBRARY})
  if(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
    link_libraries(${ZLIB_LIBRARY})
  endif(HDF5_NEED_ZLIB AND ZLIB_LIBRARY)
  if(HDF5_NEED_SZIP AND SZIP_LIBRARY)
    link_libraries(${SZIP_LIBRARY})
  endif(HDF5_NEED_SZIP AND SZIP_LIBRARY)
  if(HDF5_NEED_MPI AND MPI_LIBS)
    link_libraries(${MPI_LIBS})
  endif(HDF5_NEED_MPI AND MPI_LIBS)
endif (ENABLE_HDF5 AND HDF5_LIBRARY)

if (NOT WIN32)
  link_libraries(m)
endif (NOT WIN32)

set(cgns_info_FILES
	cgns_info.c
	cgnsutil.c
	../common/getargs.c)

add_executable(cgns_info ${cgns_info_FILES})
add_dependencies(cgns_info cgns_static calclib)

# plot3d_to_cgns
set(plot3d_to_cgns_FILES 
	plot3d_to_cgns.c
	cgnsutil.c
	binaryio.c
	../common/getargs.c)

add_executable(plot3d_to_cgns ${plot3d_to_cgns_FILES})
add_dependencies(plot3d_to_cgns cgns_static calclib)

# cgns_to_plot3d
set(cgns_to_plot3d_FILES 
	cgns_to_plot3d.c
	cgnsutil.c
	../common/getargs.c
	p3dfout.c)

add_executable(cgns_to_plot3d ${cgns_to_plot3d_FILES})
add_dependencies(cgns_to_plot3d cgns_static calclib)

# patran_to_cgns
set(patran_to_cgns_FILES 
	patran_to_cgns.c
	cgnsImport.c
	../common/getargs.c
	../common/hash.c)

add_executable(patran_to_cgns ${patran_to_cgns_FILES})
add_dependencies(patran_to_cgns cgns_static calclib)

# tecplot_to_cgns
set(tecplot_to_cgns_FILES 
	tecplot_to_cgns.c
	cgnsImport.c
	../common/getargs.c
	../common/hash.c)

add_executable(tecplot_to_cgns ${tecplot_to_cgns_FILES})
add_dependencies(tecplot_to_cgns cgns_static calclib)

# cgns_to_tecplot
set(cgns_to_tecplot_FILES 
	cgns_to_tecplot.c
	cgnsutil.c
	../common/getargs.c)

add_executable(cgns_to_tecplot ${cgns_to_tecplot_FILES})
add_dependencies(cgns_to_tecplot cgns_static calclib)

# cgns_to_vtk
set(cgns_to_vtk_FILES 
	cgns_to_vtk.c
	../common/getargs.c)

add_executable(cgns_to_vtk ${cgns_to_vtk_FILES})
add_dependencies(cgns_to_vtk cgns_static calclib)

# convert_location
set(convert_location_FILES 
	convert_location.c
	cgnsutil.c
	../common/getargs.c)

add_executable(convert_location ${convert_location_FILES})

# convert_variables
set(convert_variables_FILES 
	convert_variables.c
	cgnsutil.c
	../common/getargs.c)

add_executable(convert_variables ${convert_variables_FILES})
add_dependencies(convert_variables cgns_static calclib)

# convert_dataclass
set(convert_dataclass_FILES 
	convert_dataclass.c
	cgnsutil.c
	../common/getargs.c)

add_executable(convert_dataclass ${convert_dataclass_FILES})
add_dependencies(convert_dataclass cgns_static calclib)

# extract_subset
set(extract_subset_FILES
	extract_subset.c
	cgnsutil.c
	../common/getargs.c)

add_executable(extract_subset ${extract_subset_FILES})
add_dependencies(extract_subset cgns_static calclib)

# interpolate_cgns
set(interpolate_cgns_FILES
	interpolate_cgns.c
	cgnsutil.c
	../common/getargs.c)

add_executable(interpolate_cgns ${interpolate_cgns_FILES})
add_dependencies(interpolate_cgns cgns_static calclib)

if (WIN32)
  install(TARGETS
	plot3d_to_cgns
	cgns_to_plot3d
	patran_to_cgns
	tecplot_to_cgns
	cgns_to_tecplot
	cgns_to_vtk
	convert_location
	convert_variables
	convert_dataclass
	extract_subset
	interpolate_cgns
	RUNTIME DESTINATION bin)
  install(FILES
	conserved.cnv
	convert.tcl
	dimensional.cnv
	patran.tcl
	plot3d.tcl
	primitive.cnv
	tecplot.tcl
	util.tcl
	utilities.mnu
	vtk.tcl
	DESTINATION share)
else (WIN32)
  install(TARGETS
	plot3d_to_cgns
	cgns_to_plot3d
	patran_to_cgns
	tecplot_to_cgns
	cgns_to_tecplot
	cgns_to_vtk
	convert_location
	convert_variables
	convert_dataclass
	extract_subset
	interpolate_cgns
	RUNTIME DESTINATION bin/cgnstools)
  install(FILES
	conserved.cnv
	convert.tcl
	dimensional.cnv
	patran.tcl
	plot3d.tcl
	primitive.cnv
	tecplot.tcl
	util.tcl
	utilities.mnu
	vtk.tcl
	DESTINATION share/cgnstools)
endif (WIN32)

=== debian/changelog ===
libcgns (3.1.4.2-1) unstable; urgency=low

  * New upstream release
  * Standards-Version updated to 3.9.4
  * Enable the fortran bindings (Closes: #717850) (LP: #1204846)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 06 Aug 2013 14:31:48 +0200

=== debian/control ===
Source: libcgns
Section: libs
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 7), autotools-dev, cdbs, quilt,
 libhdf5-dev (>= 1.8.8), chrpath, mpi-default-dev, cmake
Standards-Version: 3.9.4
Homepage: http://cgns.sourceforge.net/
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/libcgns/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/libcgns/

Package: libcgns-dev
Section: libdevel
Architecture: any
Depends:  ${shlibs:Depends}, libcgns3.1 (= ${binary:Version}), ${misc:Depends}
Description: CFD General Notation System library
 The CFD General Notation System (CGNS) provides a general, portable, and
 extensible standard for the storage and retrieval of computational fluid
 dynamics (CFD) analysis data. It consists of a collection of conventions, and
 free and open software implementing those conventions. It is self-descriptive,
 machine-independent, well-documented, and administered by an international
 steering committee. It is also an American Institute of Aeronautics and
 Astronautics (AIAA) Recommended Practice.
 .
 This package contains the development files needed to compile software to
 use the libcgns API.

Package: libcgns3.1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CFD General Notation System library
 The CFD General Notation System (CGNS) provides a general, portable, and
 extensible standard for the storage and retrieval of computational fluid
 dynamics (CFD) analysis data. It consists of a collection of conventions, and
 free and open software implementing those conventions. It is self-descriptive,
 machine-independent, well-documented, and administered by an international
 steering committee. It is also an American Institute of Aeronautics and
 Astronautics (AIAA) Recommended Practice.

Package: libcgns3.1-dbg
Section: debug
Priority: extra
Architecture: any
Depends: libcgns3.1 (= ${binary:Version}), ${misc:Depends}
Description: CFD General Notation System library
 The CFD General Notation System (CGNS) provides a general, portable, and
 extensible standard for the storage and retrieval of computational fluid
 dynamics (CFD) analysis data. It consists of a collection of conventions, and
 free and open software implementing those conventions. It is self-descriptive,
 machine-independent, well-documented, and administered by an international
 steering committee. It is also an American Institute of Aeronautics and
 Astronautics (AIAA) Recommended Practice.
 .
 This package contains the debugging symbols of the library.

Package: cgns-convert
Section: science
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CFD General Notation System - Conversion tools
 The CFD General Notation System (CGNS) provides a general, portable, and
 extensible standard for the storage and retrieval of computational fluid
 dynamics (CFD) analysis data. It consists of a collection of conventions, and
 free and open software implementing those conventions. It is self-descriptive,
 machine-independent, well-documented, and administered by an international
 steering committee. It is also an American Institute of Aeronautics and
 Astronautics (AIAA) Recommended Practice.
 .
 This package contains the adf2hdf, hdf2adf tools.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright 2008 Sylvestre Ledru <sylvestre.ledru@inria.fr>

include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

CFLAGS+="-I/usr/include/mpi/"

DEB_CMAKE_EXTRA_FLAGS += -DENABLE_64BIT=OFF -DENABLE_HDF5=ON \
 -DENABLE_LEGACY=ON -DENABLE_SCOPING=ON -DENABLE_FORTRAN=ON


DEB_CONFIGURE_NORMAL_ARGS += --enable-shared=all --with-hdf5=/usr \
	--with-szip --enable-lfs --enable-debug

ifeq ($(DEB_BUILD_ARCH),hppa)
  DEB_CONFIGURE_NORMAL_ARGS += --disable-64bit
else
  DEB_CONFIGURE_NORMAL_ARGS += --enable-64bit
endif



install/libcgns-dev::
#	for file in $(DEB_DESTDIR)/usr/lib/* ; do \
#		chrpath -d $$file; \
#	done

get-orig-source:
	uscan --force-download --rename
